window.Otime = new function Otime(){return this;};

(function(Otime){

	Otime.siteUrl	= "";

	Otime.hashUrl	= "";

	Otime.baseUrl	= "";
	
	Otime.entityId	= 0;

	Otime.UID	= 0;

	Otime.isM	= false;

	Otime.uploadPath	= "";

	Otime.clipBoard	= "";
	
	Otime.UMIP	= "";
	
	Otime.UTIP	= "";

	Otime.userDetails	= {};

	Otime.pro_popover	= null;

	Otime.redirect		= null;
	
	// Otime.bgpicker_colors = ['#FA5C43', '#00BCF2','#52B043','#F7AF33','#A551BA','#00ABA9','#A05000','#208ed3','#ABABAB'];
	Otime.bgpicker_colors = [
		'#F44336', '#E91E63', '#9C27B0', '#673AB7', '#3F51B5', '#2196F3', '#039BE5', '#006064',
		'#1B5E20', '#827717', '#3E2723', '#616161', '#795548', '#263238', '#546E7A', '#ff7f50',
		'#dc143c', '#b8860b', '#556b2f', '#2f4f4f', '#cd5c5c', '#581845', '#900C3F', '#C70039',
		'#6DC8A4', '#AFB33E', '#de6800', '#FF4500', '#FFD700', '#008080', '#4682B4', '#6A5ACD',
		'#8A2BE2', '#00FF00', '#32CD32', '#008000', '#ADD8E6', '#00CED1', '#DA70D6', '#FFA07A'
	];
	
	Otime.isChrome	= /chrom(e|ium)/.test(navigator.userAgent.toLowerCase());
	
	Otime.sockUrl = '';
	
	Otime.notificationCount = 0;

	Otime.newPostCount = 0;

	Otime.notific_last_read		= 0;

	Otime.show_propop = function(title, desc) {
		$('#add_project').show();
		$("#project-popover #pop_title").html(title || '');
		if(Otime.isM) {
			$('#add_project').hide();
			desc = 'No project assigned.please contact your administrator.'
		}
		$("#project-popover #pop_desc").html(desc || '');
		$("#project-popover").show();
	};

	Otime.o	= ko.observable;
	Otime.a	= ko.observableArray;
	Otime.c	= ko.computed;
	Otime.i	= ko.isObservable;

	// call from footer.php
	Otime.ready	= function(callback){
		Otime.domain	= Otime.baseUrl;
		Otime.hashUrl	= Otime.siteUrl.replace(Otime.domain, "") + "/";

		// Otime.updateAssignedTasks(Otime.taskCount);
		Otime.Menu.redirect_last_access();
		Otime.Menu.initProgress();


		Otime.leave.dates.repeat	= [];
		Otime.leave.dates.non_repeat	= [];

		var item	= {},
			dt	= "";

		Date.hasLeave	= (Otime.leave.days.length > 0 && Otime.leave.date.length > 0);

		for (var i=0; i<Otime.leave.date.length; i++)
		{
			item	= Otime.leave.date[i];
			dt	= Otime.stoj(item.dayoff_date);
			if (Number(item.repeat))
			{
				Otime.leave.dates.repeat.push(dt.format("MM/DD"));
			}
			else
			{
				Otime.leave.dates.non_repeat.push(dt.format(Otime.jdf));
			}
		}

		// Initialize Outputtime score.
		if (!Otime.Otwidget && Otime.entityId && Otime.entityId == "4")
		{
			Otime.Score && Otime.Score.init();
		}

		callback && typeof callback == "function" && callback();
		return true;
	};

	Otime.attachUrl	= function(file_name){
		return Otime.fileUrl + "uploads/" + Otime.entityId + "/files/" + (file_name || "");
	};

	Otime.cloneNewInstance	= function(instanceName, url){
		if (!instanceName || !Otime[instanceName])
		{
			return false;
		}

		if (!!$.browser.msie)
		{
			Otime.Menu.loadURL(url);
		}

		setTimeout(function(){
			Otime[instanceName]	= new Otime[instanceName].constructor();
			Otime.Menu.loadURL(url);
		}, 100);
	};

	Otime.shortcut	= new function ShortCut(){
		var _this	= this;
		_this.ctrlC	= null;
		_this.ctrlV	= null;
		_this.ctrlS	= null;
		_this.ctrlI	= null;
		_this.ctrlU	= null;
		_this.ctrlZ	= null;
		_this.ctrlY	= null;
		_this.ctrlN	= null;
		_this.ctrlUp	= null;
		_this.ctrlDown	= null;
		_this.ctrlDelete	= null;
		_this.left	= null;
		_this.up	= null;
		_this.right	= null;
		_this.down	= null;
		_this.fDelete	= null;
		_this.fEsc	= null;

		_this.clear	= function(){
			$(document).unbind("keypress");
			_this.ctrlC = _this.ctrlV = _this.ctrlS = _this.ctrlI = _this.ctrlU = _this.ctrlZ =  _this.ctrlY = _this.ctrlN = _this.ctrlUp = _this.ctrlDelete	= _this.left = _this.up = _this.right = _this.down = _this.ctrlDown = _this.sDelete = _this.fEsc = null;
		};
	};

	Otime.dateFormat	= "";

	Otime.jsDateFormat	= "YYYY/MM/DD";
	Otime.jdf	= Otime.jsDateFormat;

	Otime.sqlDateFormat	= "YYYY-MM-DD";
	Otime.sdf	= Otime.sqlDateFormat;

	Otime.CustomDateFormats	= "";

	Otime.dateFormatDisp	= "";

	Otime.weekStart		= "";

	Otime.periodFormat		= null;

	Otime.leave	= {
		days: [],
		date: [],
		dates: {
			repeat:[],
			non_repeat:[]
		},
		skip: false
	};

//	Otime.Define	= function(obj, name, value) {
//		obj.__defineGetter__(name, function() { return value; });
//		obj.__defineSetter__(name, function() { return false; });
//	};

	Otime.Define	= function(obj, name, value) {
		Object.defineProperty(obj, name, {
			value: value,
			writable: false,
			enumerable: false,
			configurable: false
		});
		return true;
	};

	Otime.get_timezone_value	= function(tz){
		var matches	= tz.match(/(UTC)|(UP|UM)(\d+)/);
		$ret_val	= 0;
		if (matches && matches.length == 4)
		{
			if (!matches[1] && matches[2] && matches[3])
			{
				$ret_val	= (matches[3]-0) / ([1,1,10,100][matches[3].length])
				$ret_val	= matches[2] == "UM" ? -$ret_val : $ret_val;
			}
		}

		return $ret_val;
	};

	Otime.timeZoneValue	= 0;

//	Otime.Date	= function(dObj) {
//		dObj	= dObj || new Date();
//		var utc	= dObj.getTime() + (dObj.getTimezoneOffset() * 60000);
//		return new Date(utc + (3600000 * Otime.timeZoneValue));
//	};

	Otime.stoj	= function(date, isUTC0){
		if (typeof date == "string")
		{
			if (date=='0000-00-00 00:00:00' || date=='0000-00-00') {
				return '';
			}
//			var matches	= date.match(/(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})/);
			var matches	= date.match(/(\d{4})[-|\/](\d{2})[-|\/](\d{2}) (\d{2}):(\d{2}):(\d{2})/);
			if (matches && matches.length == 7)
			{
				if (isUTC0) {
					var dt = new Date(date.replace(' ', 'T') + ".000Z");
					var utc	= dt.getTime() + (dt.getTimezoneOffset() * 60000);

					var ret = new Date(utc + (3600000 * Otime.timeZoneValue));
					return ret;	
					// return new Date(date.replace(' ', 'T') + ".000Z");
				}

				var ret	= new Date();
				ret.setYear(matches[1]);
				ret.setMonth(Number(matches[2])-1);
				ret.setDate(matches[3]);
				ret.setHours(matches[4]);
				ret.setMinutes(matches[5]);
				ret.setSeconds(matches[6]);
				ret.setMilliseconds(0);

				return ret;
			}

//			var matches	= date.match(/^(\d{4})-(\d{2})-(\d{2})$/);
			var matches	= date.match(/^(\d{4})[-|\/](\d{2})[-|\/](\d{2})$/);
			if (matches && matches.length == 4)
			{
				var ret	= new Date();
				ret.setYear(matches[1]);
				ret.setMonth(Number(matches[2])-1);
				ret.setDate(matches[3]);
				ret.setHours(0);
				ret.setMinutes(0);
				ret.setSeconds(0);
				ret.setMilliseconds(0);

				return ret;
			}
		}
		return date;
	};

	Otime.toHrs = function(newVal){
		var _newVal	= (newVal+"").split(":");

		if (_newVal.length == 2)
		{
			newVal = _newVal[0] + "." + ((_newVal[1]*10)/6);
		}

		return newVal;
	};

//	newVal	= newVal.replace(/\d+\:(\d+)/,function(a,b){return a.replace(":"+b, "."+Math.round(b/0.6));});
	Otime.formatHrs	= function(newVal, returnNull){
		var _newVal	= (newVal+"").split(":");

		if (_newVal.length == 2)
		{
			newVal	= _newVal[0] + "." + ((_newVal[1]*10)/6);
		}

		if(!(newVal-0) && returnNull)
		{
			return "";
		}

		newVal	= newVal-0;
		if (Otime.timeSeparator == ":")
		{
			var nVal	= Math.round((newVal - Math.floor(newVal))*60);
			nVal	= (nVal<10) ? "0"+nVal : nVal;
			newVal	= Math.floor(newVal) + ":" + nVal;
		}
		else
		{
			newVal	= newVal.toFixed(2);
		}

		return newVal;
	};

	Otime.formatedDate	= function(){
		var args	= Array.prototype.slice.apply(arguments), dt = null, arr = [];

		if (Object.prototype.toString.call(args[0]) === '[object Array]')
		{
			args	= args[0];
		}
		switch (args.length)
		{
			case 0:
				dt	= new Date();
			break;
			case 1:

				if (typeof args[0] == "string" && isNaN(args[0]) && Otime.CustomDateFormats[Otime.dateFormat] && $.datepicker && $.datepicker.parseDate)
				{
					dt	= $.datepicker.parseDate("yy-mm-dd", args[0]);
				}
				else if(!args[0])	// if argument is passed like null or empty string
				{
					dt	= new Date();
				}
				else	// if arguement is number (timestamp)
				{
					dt	= new Date(args[0]);
				}
			break;
			default:
				for (var i = 0; i < 7; i++)
				{
					arr[i]	= args[i] || 0;
				}
				dt	= new Date(arr[0], arr[1], arr[2], arr[3], arr[4], arr[5], arr[6]);
			break;
		}

		return dt;
	};

	Otime.Date	= function() {
		var args	= Array.prototype.slice.apply(arguments),
			dt = new Date(),
			arr = [];

		if (Object.prototype.toString.call(args[0]) === '[object Array]')
		{
			args	= args[0];
		}

		if (args.length)
		{
			dt	= Otime.formatedDate(args);
		}
// console.log(dt.getTimezoneOffset(), Otime.timeZoneValue);
// console.log('dt -->',dt);
		var utc	= dt.getTime() + (dt.getTimezoneOffset() * 60000);	
// console.log('utc -->',new Date(utc));
		var ret = new Date(utc + (3600000 * Otime.timeZoneValue));
// console.log('ret -->', ret);
		return ret;
/*
		if (Object.prototype.toString.call(args[0]) === '[object Array]')
		{
			args	= args[0];
		}

		if (args.length)
		{
			dt	= Otime.formatedDate(args);
		}

		var utc	= dt.getTime() + (dt.getTimezoneOffset() * 60000);

		var ret = new Date(utc + (3600000 * Otime.timeZoneValue));
		
		if (ret.dst()){
			ret.setHours(ret.getHours() + 1);
		}
		return ret;*/
	};

	Otime.newDate	= function(dt){
		dt	= dt || new Date();
		var utc	= dt.getTime() + (dt.getTimezoneOffset() * 60000);
		return new Date(utc + (3600000 * Otime.timeZoneValue));
	};

	Otime.RemoveSeconds	= function(time){
		var _st_time	= time.match(/^(\d+):(\d+):(\d+) (AM|PM)/);
		if (_st_time)
		{
			time	= (_st_time[1] + ":" + _st_time[2] + " " + _st_time[4]);
		}
		return time;
	};

	Otime.Random	= function(){
		return (new Date().getTime() * Math.random()).toString(36).replace(".", "a");
	};

	Otime.NumFormat	= "N";
	Otime.Number	= function(num, format, fix){
		if (isNaN(num))
		{
			return num;
		}

		// Convert to string.
		fix	= (typeof fix == "undefined" ? 2 : fix);
		num	= (num-0).toFixed(fix-0);
//		num	+= "";

		format	= format || Otime.NumFormat || "N";
		//	N - 123,456.78		D - 123'456.78		F - 123 456,78		I - 1,23,456.78

		var	formats	= { N: ",", D: "'", F: " " };

		var expr;
		if (format != "I")
		{
			expr	= /\B(?=(\d{3})+(?!\d))/g;
			num	= num.replace(expr, formats[format]);

			if (format == "F")
			{
				num	= num.replace(".", ",");
			}
			return num;
		}

		expr = /\B(?=(\d{2})+(?!\d))/g;

		num = num.split(".");
		if (num[0].length>3)
		{
			num	= num[0].substr(0,num[0].length-3).replace(expr, ",") + "," + num[0].substr(-3) + (num[1]?"." + num[1]:"");
		}
		else
		{
			num	= num[0].substr(-3) + (num[1]?"." + num[1]:"");
		}

		return num;
	};

	Otime.preLoadImage	= function(src){
		var img	= new Image(100,100);
		img.src	= src;
	};

	$N	= Otime.Number;

//	Otime.metroClassesAll	= ["bg-marine", "bg-pink", "bg-purple", "bg-orange", "bg-red", "bg-green", "bg-blue", "bg-fb", "bg-blue-light", "bg-green-light", "bg-yellow", "bg-yellow-orange", "bg-orange-light", "bg-violet"];
	Otime.metroClassesAll	= ["bg-marine", "bg-pink", "bg-purple", "bg-orange", "bg-red", "bg-green", "bg-blue", "bg-fb", "bg-blue-light", "bg-green-light", "bg-violet"];
	Otime.metroClasses	= ["bg-red", "bg-blue-light", "bg-green-light", "bg-orange-light", "bg-violet", "bg-teal", "bg-brown", "bg-gray"];

	Otime.metroClassesClone	= Otime.metroClasses.slice(0);

	Otime.filter	= '';

	Otime.setMetro	= function(){
		var random	= Math.floor(Math.random() * (Otime.metroClassesClone.length));
		ret		= Otime.metroClassesClone[random];

		Otime.metroClassesClone.splice(random, 1);

		if (Otime.metroClassesClone.length == 0)
		{
			Otime.metroClassesClone	= Otime.metroClasses.slice(0);
		}

		return ret;
	};

	Otime.appReady = null;
	
	Otime.load	= function(view){
		Otime.filter	= '';
		$('.page-container').removeClass('no-page-header');
		if (!Otime[view+""])
		{
			return false;
		}

		var view_name	= view+"";

		view	= Otime[view];

		Otime.shortcut.clear();

		Otime.BookMark.current_view	= view;

		if(!Otime.app)
		{
			Otime.app	= new Otime.Application(view);
		}
		else
		{
			Otime.app.reload(view);
		}

		$("#plotTip").remove();
		$(document).unbind("keypress");
		Otime.app.currentViewName	= view_name;

		if(Otime.app.currentViewName == 'Tasks')
		{
			$("#main-container").addClass("np");
		}
		else
		{
			$("#main-container").removeClass("np");
		}

		if (Otime.app.currentViewName != 'TimeSheetTeam') {
			clearInterval(Otime.TimeSheetTeam.teamRefresh);
		}
/*
		if(Otime.app.currentViewName == 'TimeSheet')
		{
			$("#active-task").hide();
		}
		else
		{
			$("#active-task").show();
		}
*/
		Otime.app.currentView.init();
		typeof Otime.appReady === "function" && Otime.appReady(Otime.app);
	};

	Otime.comments_load	= function(view){

		if(!Otime.comments_app)
		{
			Otime.comments_app	= new Otime.Application(view);
		}
		else
		{
			Otime.comments_app.reload(view);
		}

		Otime.comments_app.currentView.init();
	};

	Otime.prepareObservable	= function(vars, model){
		if (vars.length > 0 && typeof model == "object")
		{
			for(var i=0; i<vars.length; i++)
			{
				if (typeof vars[i] == "string")
				{
					model[vars[i]]	= Otime.o();
				}
				else
				{
					vars[i][1]	= vars[i][1] || "";
					vars[i][2]	= vars[i][2] || "";
					model[vars[i][0]]	= Otime.o(vars[i][1] || vars[i][2]);
				}
			}
		}
		return self;
	};

	Otime.Message	= "";

//	Otime.set_view	= function(view){
//		Otime.app.currentView	= view;
//	};

	/**
	 * 
	 * @param url (string) - URL to call AJAX request.
	 * @param data (JSON [obj or string]) - data to post in ajax request.
	 * @param callback (function) - Callback function for Success result.
	 * @param prepare (string) - prepare "items" key value pair to obj.
	 * @param onError (function) - Callback function for Error result.
	 * @param afterClbk (function) - will call after calling callback.
	 * 
	 * @returns (instance) - returns new ContextModel Instance.
	 * 
	 */
	Otime.ContextModel	= function(url, data, callback, prepare, onError, afterClbk){
		var self		= this;

		var _data	= {};
		if (typeof url == "object")
		{
			_data	= url;
		}

		self.type		= _data.type || "POST";
		self.response	= false;
		self.dataType	= _data.dataType || "JSON";
		self.params		= _data.params || "";
		self.is_context	= true;

		self.url		= _data.url || url || "info";
		self.data		= _data.data || data || {};
		self.callback	= _data.callback || callback || null;
		self.prepare	= _data.prepare || prepare || false;
		self.onError	= _data.onError || onError || null;
		self.after_callback	= _data.afterClbk || afterClbk || null;
		self.global		= _data.global === false ? false : true;

		return self;
	};

	Otime.noLoading	= function(){
		$("body").addClass("not");
	};

	Otime.Application = function(view){

		var self	= this;

		self.currentView	= view;

		self.currentViewName	= "";

		self.is_edit_mode	= Otime.o(false);

		self.model		= null;

		self.listing	= null;

		self.context	= null;

		self.is_ajax_progress	= false;

		self.ajaxQueue	= new Array();

		self.running_process	= Otime.o(null);

		self.is_ts_running	= Otime.o(false);

		self.addRequest	= function(params){
			self.ajaxQueue.push(params);
			if (self.is_ajax_progress == false)
			{
				self.callNextAjax();
			}
		};

		self.callNextAjax	= function(){
			if (self.ajaxQueue.length > 0)
			{
				self.ajaxAction(self.ajaxQueue[0]);
			}
		};

		self.removeFromQueue	= function(){
			self.ajaxQueue.splice(0, 1);
		};

		self.ajaxAction	= function(params){
			self.is_ajax_progress	= true;

			params.success	= function(response){
				self.removeFromQueue();
				try
				{
					if (params.dataType.toUpperCase() == "JSON")
					{
						// session expiry redirect
						if (is_expired(response))
						{
							return false;
						}
						else if (response[0] == true)
						{
							var msg		= $.trim(response[1] || "");
							if (Object.keys(response[2]).length > 0)
							{
								response	= response[2];
								if (params.context.prepare === true)
								{
									response	= response.otvalues.setKeys(response.otkeys);
								}
								else if (typeof(params.context.prepare) == typeof("STRING") && response[params.context.prepare] && Object.keys(response[params.context.prepare]).length > 0)
								{
									response[params.context.prepare]	= response[params.context.prepare].otvalues.setKeys(response[params.context.prepare].otkeys);
								}
							}
							if (msg != undefined && msg != "")
							{
								Otime.Message	+= Otime.success_message(msg);
//								Otime.success_message(msg, $("#alert_message"));
							}
							params.context.response	= response;
							params.context.callback && params.context.callback(params.context);
						}
						else if (response[0] == false)
						{
							if (typeof params.context.onError == "function")
							{
								params.context.response	= response;
								params.context.onError(response[1], params.context);
							}
	
							response[1]	= $.trim(response[1]);
							if(response[1])
							{
								Otime.error_message(response[1], $(".popover #alert_message, #alert_message"));
							}
						}
						else
						{
							params.context.response	= response;
							params.context.callback && params.context.callback(params.context);
						}
					}
					else
					{
						params.context.callback && params.context.callback(response);
					}
				}
				catch(ex)
				{
					console.log("Exception : ", ex);
				}
				self.is_ajax_progress	= false;
				self.callNextAjax();
			};

			params.error	= function(xhr, ajaxOptions, thrownError){
				self.removeFromQueue();
				self.is_ajax_progress	= false;
				console.log(xhr.status);
				console.log(thrownError);
			};

			params.global	= params.global === false ? false : true;

			if (!params.global)
			{
				params.beforeSend	= function(jqXHR){
					var ts	= Math.floor(new Date().getTime() / 1000);
					jqXHR.setRequestHeader("time", ts);
					jqXHR.setRequestHeader("_t", getToken(ts));
//					jqXHR.setRequestHeader("Cache-Control", 'no-cache');
				};
			}

			$.ajax(params);
		};

		self.load_template	= function(path, callback, full_url, global){
			var url		= (full_url)?path:(Otime.siteUrl + "/" + self.currentView.name + "/template/" + path);
			var context	= new Otime.ContextModel(url, {v:Otime.version}, callback);
			context.type	= "GET";
			context.dataType	= "HTML";

			var params	= {
				url: url,
				type: "GET",
				dataType: "HTML",
				data: context.data,
				context: context,
				global: global
			};
			self.addRequest(params);
		};

		self.loadData	= function(objContext, full_url){
			if (!objContext)
			{
				return false;
			}

			var url	= (full_url) ? objContext.url : (Otime.siteUrl + "/" + (objContext.module_name || self.currentView.name) + "/" + objContext.url);
			var params	= {
				url: url,
				type: objContext.type,
				dataType: objContext.dataType,
				data: objContext.data,
				cache: false,
				context: objContext,
				global: objContext.global
			};
			self.addRequest(params);
		};

		self.postData	= function(objContext, full_url){
			if (!objContext)
			{
				return false;
			}

			self.loadData(objContext, full_url);
		};

		self.reload		= function(view){
			self.currentView	= view;
			self.is_edit_mode(false);
			self.listing	= null;
			self.context	= null;
			return true;
		};

		self.onAfterInit	= null;

		self.hasBinding	= function(elem){
			return $.trim(elem.html()) != "";
		};
	};

	Otime.DropDownModel	= function(data){
		var self = this;

		self.label	= Otime.o(data.label || "");
		self.value	= Otime.o(data.value || "");
		self.id		= Otime.o(data.id || 0);

		return self;
	};

	Otime.error_message	= function(message, parent, delay){
		message	= '<div class="alert alert-danger"><button type="button" class="close" data-dismiss="alert">&times;</button>' + message + '</div>';
//		setTimeout(Otime.removeAlerts, delay || 3000);
		return (!parent) ? message : parent.html(message);
	};

	Otime.success_message	= function(message, parent, delay){
		message	= '<div class="alert alert-success">' + message + '</div>';
		setTimeout(Otime.removeAlerts, delay || 2000);
		return (!parent) ? message : parent.html(message);
	};
	Otime.HtmlEncode	= function(s){
		var el	= document.createElement("div");
		el.innerText	= el.textContent = s;
		s	= el.innerHTML;
		return s;
	};

	Otime.removeAlerts	= function(){
		$(".alert.alert-success").remove();
	};

	Otime.Swap	= function(from, to){
		from([to(), to(from())][0]);
	};

	Otime.FormatDate	= function(objDate, strFormat){
		objDate		= objDate || new Date();
		strFormat	= strFormat || Otime.dateFormat || "MMM dd, yyyy";
		return objDate.format(strFormat);
	};

	Otime.timeConvert = function(n) {
		var num = n;
		var hours = (num / 60);
		var rhours = Math.floor(hours);
		var minutes = (hours - rhours) * 60;
		var rminutes = Math.round(minutes);
		var title;
		if (rhours > 0) {
			title = rhours + "h "
		}
		if (rminutes > 0) {
			if (rminutes > 1) {
				if (rhours > 0) {
					title = title + rminutes + "m "
				}
				else {
					title = rminutes + "m "
				}
			}
			else {
				if (rhours > 0) {
					title = title + rminutes + "m "
				}
				else {
					title = rminutes + "m "
				}
			}
		}

		return title;
	}

	Otime.Storage	= new function(){
		var _this	= this;

		_this.keyPrefix	= "";

		_this.get	= function(key, _default){
			if (window.localStorage != undefined && window.localStorage.length>0 && key)
			{
				return window.localStorage.getItem(_this.keyPrefix + key) || _default;
//				var data	= JSON.parse(window.localStorage.getItem("OTIME")) || {};
//				return ((!key) ? data : data[key]);
			}
			return false;
		};

		_this.set	= function(key, val){
			if (window.localStorage != undefined && key)
			{
				window.localStorage.setItem(_this.keyPrefix + key, val);
//				var data	= JSON.parse(window.localStorage.getItem("OTIME")) || {};
//				data[key]	= val;
//				window.localStorage.setItem("OTIME", JSON.stringify(data));
				return true;
			}
			return false;
		};

		_this.clear	= function(){
			var keys = Object.keys(window.localStorage);
			for (var i=0, iLen=keys.length; i<iLen; i++)
			{
				if (keys[i].substr(0,5) == _this.keyPrefix)
				{
					delete window.localStorage[keys[i]];
				}
			}
//			window.localStorage.clear();
			return _this;
		};

		_this.onChange	= function(callback){
			if (!$.browser.msie)
			{
				$(window).unbind("storage").bind("storage", function(e){
					callback && callback(e.originalEvent);
				});
			}
			return _this;
		};
		return _this;
	};

	Otime.minifyDate	= function(fromDt, toDt, isNS){
//console.log("Minify : ", fromDt);
		fromDt	= (fromDt instanceof Date) ? fromDt : new Date(fromDt);
		toDt	= (toDt instanceof Date) ? toDt : new Date(toDt);

		if (fromDt.toInt() == toDt.toInt() && !isNS)
		{
			return fromDt.format(Otime.dateFormat);
		}

		format	= "DD";

		if (fromDt.getFullYear() != toDt.getFullYear())
			format	= "DD MMM, YYYY";
		else if (fromDt.getMonth() != toDt.getMonth())
			format	= "DD MMM";

		return (fromDt.format(format) + toDt.format(" - DD MMM, YYYY"));
	};

	Otime.sortByKey	= function(array, key, desc){
		var ret	= array.sort(function(a, b){
			var x = a[key]; var y = b[key];
			return ((x < y) ? -1 : ((x > y) ? 1 : 0));
		});
		if (desc)
		{
			ret.reverse();
		}
		return ret;
	};

	Otime.resizePageSlide = function(){
		var $pageSlide = $(".page_slide");
		if($pageSlide.get(0)){
			var $slideLayOut = $(".page_slide_layout",$pageSlide);
			if($slideLayOut.get(0)){
				var windowHeight = $(window).height() - $pageSlide.offset().top;
				var slideHeight = $slideLayOut.height();
				var calcHeight = 0;
				if(windowHeight>slideHeight){
					calcHeight = windowHeight;
				}else{
					calcHeight = slideHeight;
				}
				$pageSlide.height(calcHeight);
			}
		}
	};

	Otime.Days	= {
		prevDaysCnt: function(d) {
			var weekStartPos	= Otime.Days.getPos(Otime.weekStart);
			var pos		= this.getDayPosWeek(d);
			var calc	= 0;
			if(weekStartPos > pos)
			{
				calc	= -(7-(weekStartPos-pos));
			}
			else
			{
				calc	= -(pos-weekStartPos);
			}
			return calc;
		},
		nextDaysCnt: function(d) {
			var weekStartPos	= Otime.Days.getPos(jhelper.weekStart);
			var pos		= this.getDayPosWeek(d);
			var calc	= (7 - pos);
			return calc + (7 - calc);
		},
		getDayPosWeek: function(d) {
			return Otime.Days.getPos(d.format("dddd"));
		},
		daysList: ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"],
		getPos: function(day) {
			return Otime.Days.daysList.indexOf(day.toLowerCase())+1;
		},
		get_time_difference: function(earlierDate, laterDate) {
			return jhelper.get_time_difference(earlierDate, laterDate);
		},
		formatAMPM: function(date) {
			if (typeof date != "string")
			{
				var hours	= date.getHours();
				var minutes	= date.getMinutes();
				var ampm	= (hours >= 12 ? "PM" : "AM");
				hours	= hours % 12;
				hours	= (hours ? hours : 12);
				hours 	= (hours<10 ? "0" + hours : hours);
				minutes = (minutes<10 ? "0" + minutes : minutes);
				return (hours + ":" + minutes + " " + ampm);
			}
		}
	};

	var ctrlKeyMap	= {
		38: "ctrlUp",
		40: "ctrlDown",
		67: "ctrlC", 99: "ctrlC",
		86: "ctrlV", 118: "ctrlV",
		83: "ctrlS", 115: "ctrlS",
		73: "ctrlI", 105: "ctrlI",
		85: "ctrlU", 117: "ctrlU",
		90: "ctrlZ", 122: "ctrlZ",
		89: "ctrlY", 121: "ctrlY",
		77: "ctrlN", 110: "ctrlN",
		46: "ctrlDelete"
	};

	var keyMap	= {
		38: "up",
		40: "down",
		27: "fEsc"
	};

	Otime.KeyPress	= function(e){
		var key	= null;
		if (e.ctrlKey)
		{
			key	= ctrlKeyMap[e.which || e.keyCode];
		}
		else
		{
			key	= keyMap[e.which || e.keyCode];
		}

		if (key && Otime.shortcut && typeof Otime.shortcut[key] == "function")
		{
			Otime.shortcut[key]();
			return false;
		}

		return true;
	};
	
	Otime.date_filter = function (self, infos, clbk) {
		infos	= infos || {};

		self.date_filter = {
			diff : Otime.o(1),
			is_dft : Otime.o(false),
			from_date : Otime.o(new Date().format(Otime.jdf)),
			to_date : Otime.o(new Date().addDays(1).format(Otime.jdf)),

			fd_td_apply : function(){
				if(self.date_filter.from_date() > self.date_filter.to_date())
				{
					alert('Start date should not be greater than end date');
					return false;
				}

				self._info.date_filter_type("CU");
				self._info.date_filter_disp("Custom");

				self.updateDateDisplay({
					from_date : new Date(self.date_filter.from_date()),
					to_date : new Date(self.date_filter.to_date())
				});				
				self.date_filter.is_dft(false);
			},

			applyDFT : function(type){
				self._info.date_filter_type(type);
//				var txt = Otime[page].filter_labels[type];
//				if (Otime[page].language)
//					self._info.date_filter_disp(Otime[page].language[txt] || txt);
//				else
//					self._info.date_filter_disp(txt);
				if (infos.filter_labels && infos.filter_labels[type]) {
					var txt	= infos.filter_labels && infos.filter_labels[type];
					self._info.date_filter_disp((infos.language && infos.language[txt]) || txt);
				
					self.date_filter.is_dft(false);
					self.updateDateDisplay(Otime.getFilterDates(new Date(self.date()), type, self));
				} else {
					self.date_filter.fd_td_apply();
				}
			}
		};

		self.date_filter.fd_disp	= Otime.o(new Date(self.date_filter.from_date()).format(Otime.dateFormat)),
		self.date_filter.td_disp	= Otime.o(new Date(self.date_filter.to_date()).format(Otime.dateFormat)),

		self.date_filter.from_date.subscribe(function(newVal){
			self.date_filter.fd_disp(new Date(newVal).format(Otime.dateFormat));
			self.updateDateDisp();
		});

		self.date_filter.to_date.subscribe(function(newVal){
			self.date_filter.td_disp(new Date(newVal).format(Otime.dateFormat));
			self.updateDateDisp();
		});

		self.updateDateDisp	= function(){
			self.date_disp(Otime.minifyDate(self.date_filter.from_date(), self.date_filter.to_date()));
		};

		var dtFlag	= false;
		self.dateUpDown	= function(nav){
			self.updateDateDisplay(Otime.getFilterDates(new Date(self.date()), self._info.date_filter_type(), self, nav));
		};

		self.date.subscribe(function(newVal){
			if (self._info.date_filter_type()!='CU')
				self.updateDateDisplay(Otime.getFilterDates(new Date(self.date()), self._info.date_filter_type()));
		});

		self.updateDateDisplay	= function(dateDiff){

			if (self._info.date_filter_type()!='CU' && dateDiff.current_date && new Date(self.date()).format(Otime.jdf) != dateDiff.current_date.format(Otime.jdf))
			{
				self.date(dateDiff.current_date.format(Otime.jdf));
				return true;
			}

			var fromDt	= new Date(dateDiff.from_date).format(Otime.jdf),
				toDt	= new Date(dateDiff.to_date).format(Otime.jdf);

				self.date_filter.from_date(fromDt);
			self.date_filter.to_date(toDt);

			self.date_disp(Otime.minifyDate(fromDt, toDt));
			infos.date_changed && infos.date_changed(self);

			clbk && typeof clbk == "function" && clbk();
		};
	};

	Otime.getFilterDates = function(current, type, self, nav){
		var from_date	= "",
			to_date		= "",
			ret	= "";

		if (!current || !1 == current instanceof Date)
		{
			return !1;
		}

	//	self	= (self && self instanceof Otime.Report.ReportModel) ? self : !1;
		current	= (self && typeof self.today == "function" && nav == undefined) ? new Date(self.today()) : current;

		switch(type || "TW")
		{
			case 'TO':	// Today
				if (self && nav != undefined)
				{
					current.addDays(Number(nav + "1"));
				}
				from_date	= new Date(current.getFullYear(), current.getMonth(), current.getDate());
				to_date		= new Date(current.getFullYear(), current.getMonth(), current.getDate());
				break;
			case 'TW':	// This Week
				default:
				if (self && nav != undefined)
				{
					current.addDays(Number(nav + "7"));
				}
				var dy	= new Date(current.getFullYear(), current.getMonth(), current.getDate());
				dy.addDays(Otime.Days.prevDaysCnt(dy));
				from_date	= new Date(dy);
				to_date		= dy.addDays(6);
				break;
			case 'TS':	// This Semi-Monthly
				if (self && nav != undefined)
				{
					current.addDays(Number(nav + "15"));
				}

				if (current.getDate() <= 15)
				{
					from_date	= new Date(current.getFullYear(), current.getMonth(), 1);
					to_date		= new Date(current.getFullYear(), current.getMonth(), 15);
				}
				else
				{
					from_date	= new Date(current.getFullYear(), current.getMonth(), 16);
					to_date		= new Date(current.getFullYear(), current.getMonth()+1, 0);
				}
				break;
			case 'TM':	// This Month
				if (self && nav != undefined)
				{
					current.addMonth(Number(nav + "1"));
				}
				from_date	= new Date(current.getFullYear(), current.getMonth(), 1);
				to_date		= new Date(current.getFullYear(), current.getMonth()+1, 0);
				break;
			case 'TQ':	// This Quarter
				if (self && nav != undefined)
				{
					current.addMonth(Number(nav + "3"));
				}
				from_date	= new Date(current.getFullYear(), (Math.ceil((current.getMonth()+1)/3)-1)*3, 1);
				to_date		= new Date(current.getFullYear(), ((Math.ceil((current.getMonth()+1)/3)-1)*3)+3, 0);
				break;
			case 'TY':	// This Year
				if (self && nav != undefined)
				{
					current.addYear(Number(nav + "1"));
				}
				from_date	= new Date(current.getFullYear(), 0, 1);
				to_date		= new Date(current.getFullYear()+1, 0, 0);
				break;
			case 'TA':	// This Accounting year
				if (self && nav != undefined)
				{
					current.addYear(Number(nav + "1"));
				}
				var full_year = current.getFullYear()-1;
				if (current.getMonth()+1 >= Otime.fiscal_year_month) {
					full_year = current.getFullYear();
				}
				from_date	= new Date(full_year, (Otime.fiscal_year_month || 4)-1, 1);
				to_date		= new Date(full_year+1, (Otime.fiscal_year_month || 4)-1, 0);
				break;
			case 'YE':	// Yesterday
				if (self && nav != undefined)
				{
					current.addDays(Number(nav + "1"));
				}
				from_date	= new Date(current.getFullYear(), current.getMonth(), current.getDate()-1);
				to_date		= new Date(current.getFullYear(), current.getMonth(), current.getDate()-1);
				break;
			case 'LW':	// Last Week
				if (self && nav != undefined)
				{
					current.addDays(Number(nav + "7"));
				}
				var dy	= new Date(current.getFullYear(), current.getMonth(), current.getDate());
				dy.addDays(Otime.Days.prevDaysCnt(dy) - 7)
				from_date	= new Date(dy);
				to_date		= dy.addDays(6);
				break;
			case 'LS':	// Last Semi-Monthly
				if (self && nav != undefined)
				{
					current.addDays(Number(nav + "15"));
				}
				if (current.getDate() <= 15)
				{
					from_date	= new Date(current.getFullYear(), current.getMonth()-1, 16);
					to_date		= new Date(current.getFullYear(), current.getMonth(), 0);
				}
				else
				{
					from_date	= new Date(current.getFullYear(), current.getMonth(), 1);
					to_date		= new Date(current.getFullYear(), current.getMonth(), 15);
				}
				break;
			case 'LM':	// Last Month
				if (self && nav != undefined)
				{
					current.addMonth(Number(nav + "1"));
				}
				from_date	= new Date(current.getFullYear(), current.getMonth()-1);
				to_date		= new Date(current.getFullYear(), current.getMonth(), 0);
				break;
			case 'LQ':	// Last Quarterly
				if (self && nav != undefined)
				{
					current.addMonths(Number(nav + "3"));
				}
				from_date	= new Date(current.getFullYear(), ((Math.ceil((current.getMonth()+1)/3)-1)*3)-3, 1);
				to_date		= new Date(current.getFullYear(), (Math.ceil((current.getMonth()+1)/3)-1)*3, 0);
				break;
			case 'LY':	// Last Year
				if (self && nav != undefined)
				{
					current.addYear(Number(nav + "1"));
				}
				from_date	= new Date(current.getFullYear()-1, 0, 1);
				to_date		= new Date(current.getFullYear(), 0, 0);
				break;
			case 'LA':	// Last Accounting Year
				if (self && nav != undefined)
				{
					current.addYear(Number(nav + "1"));
				}
				var full_year = current.getFullYear()-1;
				if (current.getMonth()+1 >= Otime.fiscal_year_month) {
					full_year = current.getFullYear();
				}
				from_date	= new Date(full_year-1, (Otime.fiscal_year_month || 4)-1, 1);
				to_date		= new Date(full_year, (Otime.fiscal_year_month || 4)-1, 0);
				break;
			case 'CU':
				if (self && nav != undefined)
				{
					from_date = typeof self.date_filter.from_date().getMonth === 'function'?self.date_filter.from_date():new Date(self.date_filter.from_date()) ;
					to_date = typeof self.date_filter.to_date().getMonth === 'function'?self.date_filter.to_date():new Date(self.date_filter.to_date()) ;

					var noOfDays	= Number(nav + (1+ ((to_date.getTime() - from_date.getTime()) / 864E5)));
					from_date	= new Date(self.date_filter.from_date()).addDays(noOfDays);
					to_date	= new Date(self.date_filter.to_date()).addDays(noOfDays);
					current	= new Date(current).addDays(noOfDays);

					self._info.date_filter_disp("Custom");
				}
				break;
		}

		ret	= {
			current_date : current,
			from_date : from_date,
			to_date : to_date
		};

		return ret;
	};

	Otime.AttachmentDetailModel	= function(data){
		var self	= this;

		data	= data || {};
//		var exts	= ['jpg','png','gif','jpeg'];

		self.attachment_id	= Otime.o(data.attachment_id || 0);
		self.file_type		= Otime.o(data.file_type || "");
		data.file_name		= (data.file_name) ? data.file_name.replace(/^.*\\/, "") : "";
		self.file_name		= Otime.o(data.file_name || "");
		self.module_type	= Otime.o(data.module_type || "");
		self.module_id		= Otime.o(data.module_id || 0);
		self.file_path		= Otime.o(data.file_path || "");
		self.file_size		= Otime.o(data.file_size-0);
		self.encrypt_key	= Otime.o(data.encrypt_key || "");
//		self.extension		= ($.inArray(self.file_type(), exts ) < 0 ) ? self.file_type() : 'image';
		self.posted_by		= Otime.o(data.posted_by || 0);
		data.posted_date	= (data.posted_date ? Otime.stoj(data.posted_date) : Otime.Date().getTime());
		self.posted_date	= Otime.o(new Date(data.posted_date).format(Otime.dateFormat || "MMM dd, yyyy"));
//		self.is_tooltip		= Otime.o(false);
		self.fsize			= Otime.o("");

		if (data.file_size > 0)
		{
			self.fsize(Math.round(data.file_size / 1024) + "KB");
		}

		self.encrypted_url	= Otime.o();
		self.download_url	= Otime.o();
		self.tooltip = Otime.o();
//		self.tooltipContent	= Otime.o();

		self.compute	= Otime.c(function() {
			self.encrypted_url(Otime.baseUrl + "index.php/attachment/file/" +self.encrypt_key());
			self.download_url(Otime.baseUrl+"index.php/attachment/download/"+self.encrypt_key());

			var tooltip	= "";
			tooltip += self.file_name() + "." + self.file_type() + "\n";
			tooltip += "File Size :\t\t\t" + bytesToSize(self.file_size()) + "\n";
			tooltip += "Posted by :\t\t" + self.posted_by() + "\n";
			tooltip += "Date Modified :\t" + self.posted_date();

			self.tooltip(tooltip);
		});

		return self;
	};

	Otime.updateAssignedTasks	= function(val){
		if (val)
		{
			val	= val < 10 ? "&nbsp;"+val : val;
			$("#task-count").html(val).show();
			
		}
		else
		{
			$("#task-count").hide();
		}
	};

	// unbind js event
	Otime.unbind = function(){
		$(document).unbind("mousewheel").unbind("scroll").unbind("keydown");
		$("#main-container").unbind("mousewheel");
		$(".page-container").unbind("scroll");
	};

	Otime.loadTemplates	= function(url, data, clbk, localStorageName){
		localStorageName = "tmpl_" + localStorageName;

		if (Otime.env!='development' && localStorageName.indexOf("_wall_") == -1 && Otime.Storage.get(localStorageName))
		{
			clbk(Otime.Storage.get(localStorageName));
			return true;
		}
		return $.get(url, data, function(content, a, jqXHR){
			if (jqXHR.getResponseHeader("Content-Type").toLowerCase().indexOf("text/html") > -1)
			{
				Otime.Storage.set(localStorageName, content);
				clbk(content);
			}
		});
	};

	Otime.onTabChange	= function(clbk){

		var targEvent	= "hidden";

		var onchange	= function(evt){
			var v	= "visible",
				h	= "hidden",
				evtMap	= {
					focus: v,
					focusin: v,
					pageshow: v,
					blur: h,
					focusout: h,
					pagehide: h
				};

			evt	= evt || window.event;

			var isHidden	= (evtMap[evt.type] != undefined) ? evtMap[evt.type] : document[targEvent];

			clbk && typeof clbk == "function" && clbk(isHidden);
		};

		if (typeof document.hidden !== "undefined") {
			targEvent	= "hidden";
			document.addEventListener("visibilitychange", onchange);
		} else if(typeof document.mozHidden !== "undefined") {
			targEvent	= "mozHidden";
			document.addEventListener("mozvisibilitychange", onchange);
		} else if(typeof document.webkitHidden !== "undefined") {
			targEvent	= "webkitHidden";
			document.addEventListener("webkitvisibilitychange", onchange);
		} else if(typeof document.msHidden !== "undefined") {
			targEvent	= "msHidden";
			document.addEventListener("msvisibilitychange", onchange);
		} else if (typeof document.onfocusin !== "undefined") {
			document.onfocusin = document.onfocusout = onchange;
		} else {
			window.onpageshow = window.onpagehide = window.onfocus = window.onblur = onchange;
		}

		return;
	};

}(window.Otime));

/* Javascript Prototypes and Functions Begins */
if (!window.console || !window.console.log)
{
	window.console	= {log: function(){return true;}};
}
window.echo	= window.console.log;
window.print_R	= window.console.log;
window.print_r	= window.console.log;
//window.OUMCallback	= function(cnt){
//	console.log("OUM Called : ", cnt);
//	$("#chat-count").html(cnt);
//};

$(function(){
	// Handle messages from OMBro iframe message.
	$(window).on("message", function(e){
		if (e && e.originalEvent && e.originalEvent.data)
		{
			try {
				var data	= typeof e.originalEvent.data=='object'?e.originalEvent.data:JSON.parse(e.originalEvent.data);
				if (data)
				{
					$("#chat-count").html(data.count || "");
				}
			}
			catch (e){
				console.log("Error : ", e);
			}
		}
	});

	$("#bookmark-container").mouseleave(function(){
		$("#bookmark-container").hide();
	});
	$("#bookmark").unbind("click").click(function(){
		Otime.BookMark.init();
	});

	$(".company-name").unbind("click").click(function(e){
		if (e.ctrlKey && e.altKey && e.shiftKey && confirm("Are you want to clear ?"))
		{
			localStorage.clear();
		}
	});
	$(window).resize(Otime.resizePageSlide);
});

/* Javascript Prototypes and Functions End */


// Key board shortcut access\

// $(document).bind('keydown', 'ctrl+c', fn);

/*

Left	- 37,
Up		- 38,
Right	- 39,
Down	- 40,
F2		- 113,
Enter	- 13,

$(document).ready(function(){
	$(document).keypress(Otime.KeyPress);
});

$.fn.isOnScreen = function(parent){
	var win	= parent || $(window);

	var viewport	= {
		top: win.scrollTop(),
		left: win.scrollLeft()
	};

	viewport.right	= viewport.left + win.width();
	viewport.bottom	= viewport.top + win.height();

	var bounds	= this.offset();
	bounds.right	= bounds.left + this.outerWidth();
	bounds.bottom	= bounds.top + this.outerHeight();

	return (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));
};

*/
